/* -*-c-*-
 *
 * Pool-generation boundary machinery (Unix-specific)
 *
 * (c) 2016 Straylight/Edgeware
 */

/*----- Licensing notice --------------------------------------------------*
 *
 * This file is part of Catacomb.
 *
 * Catacomb is free software; you can redistribute it and/or modify
 * it under the terms of the GNU Library General Public License as
 * published by the Free Software Foundation; either version 2 of the
 * License, or (at your option) any later version.
 *
 * Catacomb is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU Library General Public License for more details.
 *
 * You should have received a copy of the GNU Library General Public
 * License along with Catacomb; if not, write to the Free
 * Software Foundation, Inc., 59 Temple Place - Suite 330, Boston,
 * MA 02111-1307, USA.
 */

/*----- Header files ------------------------------------------------------*/

#include <unistd.h>

#include "rand.h"

/*----- Main code ---------------------------------------------------------*/

/* --- @rand_generation@ --- *
 *
 * Arguments:	---
 *
 * Returns:	A nonzero generation number.
 *
 * Use:		Returns a generation number for the current process.  Each
 *		pool has its own number.  If this matches the process number
 *		then all is well.  If it doesn't match, then the pool needs
 *		to be cleaned before its next use.
 */

unsigned rand_generation(void) { return (getpid()); }

/*----- That's all, folks -------------------------------------------------*/
